/* AbiWord: ie_imp_HTML - plugin for non-XHTML HTML
 * Copyright (C) 2002 Francis James Franklin <fjf@alinameridon.com>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 */


#ifndef IE_IMP_HTML_H
#define IE_IMP_HTML_H

#include <stdio.h>

#include "HTML_Parser.h"

#include "ut_xml.h"
#include "ie_imp.h"

class UT_GrowBuf;
class PD_Document;
class IE_Imp;

class ABI_EXPORT IE_Imp_HTML_Sniffer : public IE_ImpSniffer
{
  friend class IE_Imp;

 public:
  IE_Imp_HTML_Sniffer () { }
  ~IE_Imp_HTML_Sniffer () { }

  bool recognizeContents (const char * szBuf, UT_uint32 iNumbytes);
  bool recognizeSuffix (const char * szSuffix);
  bool getDlgLabels (const char ** szDesc, const char ** szSuffixList, IEFileType * ft);

  UT_Error constructImporter (PD_Document * pDocument, IE_Imp ** ppie);
};

class ABI_EXPORT IE_Imp_HTML : public IE_Imp, public HTML_Parser::Listener
{
 public:
  IE_Imp_HTML (PD_Document * pDocument);
  ~IE_Imp_HTML ();

  UT_Error importFile (const char * szFilename);

  // implementation of HTML_Parser::Listener
  void startElement (const char * name, const char ** atts);
  void endElement (const char * name);
  void charData (const char * buffer, int length);

 private:
  void flushData ();

  enum CharDataMode
  {
    cdm_Ignore,
    cdm_Title,
    cdm_Body
  };

  CharDataMode m_CharDataMode;

  UT_GrowBuf * m_pGB;

  HTML_Parser * m_pHTML;
};

#endif /* IE_IMP_HTML_H */
